/* 
   manae --- skimple kana MANA Exchanger
   manae.h --- Main header file
   Copyright 1998-2000 IWAMA Naozumi

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _MANAE_H_
#define _MANAE_H_

#define SPad

#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "completion2.h"

#define VERSIONSTR2	"΁[/manae ver. 1.38"
#define VERSION		 13800
#define DBVERSION	 2

typedef struct {
  // version
  UInt version;
  UInt dbVersion;
  // system encoding
  ULong encoding;

  // static valiables
  //  STATICVALUES;
  FieldPtr fld;
  Byte mode;
  Byte kanjiMode;
  Boolean nonSkkMode;
  Boolean thumbTypeMode;
  Byte guiMode;
  Boolean locked;
  Word insPtPosition;
  Short insPtX;
  Short insPtY;
  Short kanjiStartX;
  Short kanjiStartY;
  Int candNum;
  Int numOfCand;
  Int dicType;
  Int currDicType;
  Int candsOffset;
  Int userCandsOffset;
  Int learnCandsOffset;
  Int currCandOffset;
  Int userCurrCandOffset;
  Int okuriStartPosition;
  ULong candRecLen;
  ULong userDicLen;
  ULong learnDicLen;
  //  CharPtr nextStartP;
  Int nextStart;
  Char consonant;
  Char consonant1;
  Char consonant2;
  Char consonant3;
  Char consonant4;
  Char consonant5;
  Char consonant6;
  Char okuriC;
  Char henkan;
  Char kakutei;
  Char alpha2HiraC;
  Char hira2AlphaC;
  Char hira2KataC;
  Char hira2ZenC;
  Char kata2AlphaC;
  Char kata2HiraC;
  Char kata2ZenC;
  Char zen2HiraC;
  Char kuten;
  Char kuten2;
  Char kuten3;
  Char kuten4;
  Char kuten5;
  Char kuten6;
  Char touten;
  Char touten2;
  Char touten3;
  Char touten4;
  Char touten5;
  Char touten6;

  // for buffer
  Boolean flush;
  
  // (former) global valiables
  // kanae & manae valiables
  DmOpenRef db; // kanae hack db itself
  DmOpenRef manaeDB; // current status records
  DmOpenRef kanjiDB; // for J-OS kanji dic.
  DmOpenRef memoDB; // for J-OS user dic.
  VoidHand dicH; // 
  VoidHand userDicH; // 
  CharPtr userDicP; // 
  UInt learnDicI; // learn dic index
  VoidHand learnDicH;
  CharPtr learnDicP;
  Int learnDicStartPoint;

  EventPtr event;
  UInt consonantIndex; // consonant index

  VoidHand staticH; // consonant buffer handle
  VoidPtr staticP;  // consonant buffer pointer
 
  Boolean handled;
  VoidHand seionH;
  VoidPtr seionP;
  VoidHand dakuonH;
  VoidPtr dakuonP;
  VoidHand youon1H;
  VoidPtr youon1P;
  VoidHand youon2H;
  VoidPtr youon2P;
  VoidHand kanakigouH;
  VoidPtr kanakigouP;
  VoidHand kigouH;
  VoidPtr kigouP;
  
  // kanae valiables;
  VoidHand candH; // current candidate rec handle
  CharPtr candP; // current candidate handle start point.

  VoidHand kanaH;
  CharPtr kanaP;
  VoidHand okuriH;
  CharPtr okuriP;
  VoidHand formerDrawH;
  CharPtr formerDrawP;

  // for Cands Form
  Boolean candsFrmFlg;
  Int complFlag;
  VoidHand candsH;
  CharPtr candsP;
  VoidHand selectedCandH;
  CharPtr selectedCandP;
  CharPtr candsButtonStr;
  Int currPage;
  Int maxPage;
  Int maxNumInPage;

  VoidHand convStackH;
  CharPtr convStackP;
  Int convStackCtr;

  // Preferences Record
  VoidHand prefsH;
  VoidPtr prefsP;

  Boolean printed;
  VoidHand lineBufferH;
  CharPtr lineBufferP;

  // for completion2
  DCPtr dcP;

  // for manaemori
  Word realChr;

  // for jog
  Int complSeleNum;

  // Current Application dbID
  LocalID currAppDbID;

} Global;


typedef Global * GlobalPtr;

typedef struct {
  Int len;
  Int numOfCands; // the number of cands in this rec.
  CharPtr candsP;
} PreCands;

typedef PreCands * PreCandsPtr;


// #define NOLOCK

#define FEATURE_LOCK 10
#define FEATUREGLOBAL 11
#define FEATURECANDSPAGE 12
#define FEATUREMANAEMORI 13
#define FEATURECANDSFRM 14
#define FEATUREMANAEDB 15
#define FEATURECANDSPOPUP 16

#define CREATOR 'Mnae'
#define MANAEAPPTYPE 'HACK'
#define MANAEDBTYPE 'DATA'
#define MANAEDBNAME "manaeDB"
#define MANAELEARNDICINDEX 0
#define MANAEKANAINDEX 1
#define MANAEOKURIINDEX 2
#define MANAEFORMERDRAW 3
#define MANAECANDSINDEX 4
#define MANAESELECTEDCANDINDEX 5
#define MANAEPREFSINDEX 6
#define MANAELINEBUFFERINDEX 7
// #define MANAECONSONANTINDEX 255

#define KANALEN 64
#define OKURILEN 64
#define CANDSLISTLEN KANALEN / 4
#define ALPHA 0
#define ZEN 1
#define HIRA 2
#define KATA 3
#define NONKANJI 0
#define KANJI 1
#define KANJIIN 2
#define OKURIIN 3
#define HENKAN 4

#define memoDBName "MemoDB"
#define memoDBType 'DATA'
#define NODIC	0
#define JOSDIC	1
#define USERDIC	2
#define LEARNDIC	4

#define STATICSIZE 200

#define CANDSSIZE 4000
#define CANDSMAXSIZE 2000
#define CANDSCOMPLSIZE 400
#define CANDSPERPAGE 9
#define CANDSBUTTONSTRLEN 10

#define CANDSSELECTEDMASK 0x0110
#define CANDSCANCELEDMASK 0x0120

#define LEARNDICMINSIZE 2000
#define LEARNDICMEMOSIZE 4000

#define LEARNDICMAXSIZE 16000

// this is for reservation
#define LEARNDICHEADERSIZE 64
#define LEARNDICBODYSTART 96
#define LEARNDICREDZONE 128
#define LEARNITEMSIZE 50
#define LEARNDELETESIZE 512

#define LINEBUFFERSIZE 100

#define GUINO 0
#define GUIALWAYS 0xff
#define GUIKANA 0xff
#define MODETL 1
#define MODETR 2
#define MODEBL 3
#define MODEBR 4
#define MODEDEFAULT	4
/*
#define CONVDEPTH	4
*/
#define CONVDEPTH	3
#define POPUPDEFAULT	4

#define KOHOCHR ""
#define KOHOCHRLEN 2
#define HENKANCHR ""

#define GRAFFITILETTERX 90
#define GRAFFITINUMBERX 130
#define GRAFFITIUPPER 90
#define GRAFFITILOWER 215

// ERROR
#define ERRWARNING	0x0000
#define ERRFATAL	0x8000


// from SDK 3.5
// start
#define	MySysFtrNumEncoding				11
typedef enum {
	MyCharEncodingUnknown = 0,	// Unknown to this version of PalmOS.
	
	MyCharEncodingAscii,			// ISO 646-1991
	MyCharEncodingISO8859_1,		// ISO 8859 Part 1
	MyCharEncodingPalmLatin,		// PalmOS version of CP1252
	MyCharEncodingShiftJIS,		// Encoding for 0208-1990 + 1-byte katakana
	MyCharEncodingPalmSJIS,		// PalmOS version of CP932
	MyCharEncodingUTF8,				// Encoding for Unicode
	MyCharEncodingCP1252,			// Windows variant of 8859-1
	MyCharEncodingCP932				// Windows variant of ShiftJIS
} MyCharEncodingType;
// end

#ifdef SPad
#define ALPHA2HIRA '\\'
#define HIRA2ALPHA 'l'
#define HIRA2KATA 'q'
#define HIRA2ZEN 'L'
#define KATA2ALPHA 'l'
#define KATA2HIRA 'q'
#define KATA2ZEN 'L'
#define ZEN2HIRA '\\'
#define HENKANC ' '
#define KAKUTEIC linefeedChr
#define PREVIOUSC 'x'
#endif

#ifndef SPad
#define ALPHA2HIRA '/'
#define HIRA2ALPHA '\\'
#define HIRA2KATA '+'
#define HIRA2ZEN 'L'
#define KATA2ALPHA '\\'
#define KATA2HIRA '/'
#define KATA2ZEN 'L'
#define ZEN2HIRA '/'
#endif

#endif
