/* 
   manae --- skimple kana MANA Exchanger
   manae.c --- Main Module
   Copyright 1998-2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#pragma pack(2)

#include <stdio.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <System/FeatureMgr.h>

#include "id.h"
#include "manae.h"

// This software refers Hardware/Hardware.h!
#define NON_PORTABLE
#include <Hardware/Hardware.h>

// my functions

// StrNCopy Clone.
CharPtr mystrncpy(CharPtr d, const Char* s, Word n)
{
  Word i;
  for (i = 0; ((i < n) && (s[i] != nullChr)); i++) {
    d[i] = s[i];
  }
  for (; i < n; i++) {
    d[i] = nullChr;
  }
  d[n] = nullChr;
  return(d);
}
    
// Is c consonant?
Boolean isconsonant(Char c)
{
  Int i;

  static const Char consonant[] = {'k', 's', 't', 'n', 'h', 'm', 'y', 'r', 'w',
				   'g', 'z', 'd', 'b', 'v', 'j', 'p', 'f', 'c',
				   'x', '\0'};


  for (i = 0; consonant[i] != nullChr; i++) {
    if (consonant[i] == c) return true;
  }
  return false;
}

// Is c vowel?
Boolean isvowel(Char c)
{
  Int i;

  static const Char vowel[] = {'a', 'i', 'u', 'e', 'o', '\0'};

  for (i = 0; vowel[i] != nullChr; i++) {
    if (vowel[i] == c) return true;
  }
  return false;
}

// Returned:
// a -> 0, i ->1, u ->2, e -> 3, o -> 4
// other -> 5
Int vowelNum(Char c)
{
  Int i;

  static const Char vowel[] = {'a', 'i', 'u', 'e', 'o', '\0'};

  for (i = 0; vowel[i] != nullChr; i++) {
    if (vowel[i] == c) return i;
  }
  return 5;
}

// convert space to null.
// Returned: converted -> true;
Boolean space2Null(CharPtr s)
{
  Int i;

  for(i = 0; s[i] != nullChr; i++) {
    if (s[i] == ' ') {
      s[i] = nullChr;
      return(true);
    }
  }
  return(false);
}

// add one char to the string.
// RETURNED:	new string length.
Int addChar(CharPtr str, Char c)
{
  Int i;
  for (i = 0; str[i] != nullChr; i++) {}
  
  str[i] = c;
  str[i + 1] = nullChr;
  return(i + 1);
}

CharPtr MyDmStrCat(CharPtr dst, CharPtr src)
{
  ULong dstLen, srcLen;

  for (dstLen = 0; *(dst + dstLen) != nullChr; dstLen++);
  for (srcLen = 0; *(src + srcLen) != nullChr; srcLen++);
  DmWrite(dst, dstLen, src, srcLen + 1); // + 1 for nullChr
  return(dst);
}

UInt MyDmGetOpenDatabaseVersion(DmOpenRef dbR)
{
  LocalID dbID;
  UInt openCount;
  UInt mode;
  UInt cardNo;
  Boolean resDB;

  Char name;
  UInt attributes;
  UInt version;
  ULong crDate;
  ULong modDate;
  ULong bckUpDate;
  ULong modNum;
  LocalID appInfoID;
  LocalID sortInfoID;
  ULong type;
  ULong creator;

  if (DmOpenDatabaseInfo(dbR, &dbID, &openCount, &mode, &cardNo, &resDB)
      == 0) {
    if (DmDatabaseInfo(cardNo, dbID,
		       &name, &attributes,
		       &version, &crDate,
		       &modDate, &bckUpDate,
		       &modNum, &appInfoID,
		       &sortInfoID, &type,
		       &creator) == 0) {
      return(version);
    }
  }
  return(0); // error
}

UInt MyDmGetDatabaseVersionByTypeCreator(ULong type, ULong creator)
{
  DmSearchStateType stateInfo;
  UInt cardNo;
  LocalID dbID;

  Char name;
  UInt attributes;
  UInt version;
  ULong crDate;
  ULong modDate;
  ULong bckUpDate;
  ULong modNum;
  LocalID appInfoID;
  LocalID sortInfoID;

  if (DmGetNextDatabaseByTypeCreator(true, &stateInfo, type, creator, true,
				     &cardNo, &dbID)
      == 0) {
    if (DmDatabaseInfo(cardNo, dbID,
		       &name, &attributes,
		       &version, &crDate,
		       &modDate, &bckUpDate,
		       &modNum, &appInfoID,
		       &sortInfoID, &type,
		       &creator) == 0) {
      return(version);
    }
  }
  return(0); // error
}

Err MyDmSetDatabaseVersionByTypeCreator(ULong type, ULong creator,
					UInt version)
{
  DmSearchStateType stateInfo;
  UInt cardNo;
  LocalID dbID;
  Err err;

  if ((err = DmGetNextDatabaseByTypeCreator(true, &stateInfo,
					    type, creator, true,
					    &cardNo, &dbID))
      == 0) {
    return(DmSetDatabaseInfo(cardNo, dbID,
			     NULL, NULL,
			     &version, NULL,
			     NULL, NULL,
			     NULL, NULL,
			     NULL, NULL,
			     NULL));
  }
  return(err); // error
}

Err MyDmDeleteDatabaseByTypeCreator(ULong type, ULong creator)
{
  DmSearchStateType stateInfo;
  UInt cardNo;
  LocalID dbID;
  Err err;

  if ((err = DmGetNextDatabaseByTypeCreator(true, &stateInfo,
					    type, creator, true,
					    &cardNo, &dbID))
      == 0) {
    return(DmDeleteDatabase(cardNo, dbID));
  }
  return(err);
}

WinHandle MyDrawCharSave(CharPtr chars, Word len, SWord x, SWord y)
{
  RectangleType r;
  WinHandle h;
  Word err;

  r.topLeft.x = x;
  r.topLeft.y = y;
  WinWindowToDisplayPt(&r.topLeft.x, &r.topLeft.y);
  r.extent.x = 
    ((FONTWIDTH * len / 2 + r.topLeft.x + 5) > (hwrDisplayWidth - 1)) ?
    (hwrDisplayWidth - r.topLeft.x - 1) :
    (FONTWIDTH * len / 2 + r.topLeft.x + 5);
  r.extent.y = FONTHEIGHT + 2;
  
  h = WinSaveBits(&r, &err);
  WinDrawChars(chars, len, x, y);
  return(h);
}
    
void MyRestore(WinHandle h, Word len, SWord x, SWord y)
{
  RectangleType r;

  if (h == NULL) return;

  r.topLeft.x = x;
  r.topLeft.y = y;
  WinWindowToDisplayPt(&r.topLeft.x, &r.topLeft.y);
  r.extent.x = 
    ((FONTWIDTH * len / 2 + r.topLeft.x + 5) > (hwrDisplayWidth - 1)) ?
    (hwrDisplayWidth - r.topLeft.x - 1) :
    (FONTWIDTH * len / 2 + r.topLeft.x + 5);
  r.extent.y = FONTHEIGHT + 2;
  
  WinRestoreBits(h, x, y);
  return;
}

Int GetGraffitiRegion(SWord screenX, SWord screenY, ULong encoding)
{
  SWord dispX, dispY;
  SWord currHwrGraffitiLeft;
  
  dispX = screenX;
  dispY = screenY;
  WinWindowToDisplayPt(&dispX, &dispY);

  //  currHwrGraffitiLeft = (encoding == charEncodingCP932) ? 40 : hwrGraffitiLeft;
  currHwrGraffitiLeft = (encoding == MyCharEncodingPalmSJIS) ? 45 : hwrGraffitiLeft;

  if ((dispY < hwrGraffitiTop) ||
      (dispY > hwrGraffitiTop + (hwrGraffitiHeight / 2))) {
    return(-1);
  }
  if (dispX < currHwrGraffitiLeft) {
    return(-1);
  }
  if (dispX < currHwrGraffitiLeft +
      (hwrGraffitiSplit - currHwrGraffitiLeft) / 2) {
    return(0);
  }
  if (dispX < hwrGraffitiSplit) {
    return(1);
  }
  if (dispX < currHwrGraffitiLeft + hwrGraffitiWidth) {
    return(2);
  }
  return(-1);
}

void ErrorPrintHex(ULong hex, SWord x, SWord y)
{
  Char s[15];

  StrPrintF(s, "%lx", hex);
  WinDrawChars(s, StrLen(s), x, y);
}

void ErrorPrintNum(Int i, SWord x, SWord y)
{
  Char s[35];
  StrPrintF(s, "manae error: %d", i);
  WinDrawChars(s, StrLen(s), x, y);
}
